﻿using System.Collections.Generic;
using System.IO;
using System.Runtime.InteropServices;
using System.Text;


namespace pdfforge.PDFCreator.COM
{
    [ComVisible(true)]
    public class OutputFiles
    {
        private readonly IList<string> _outputFiles;

        /// <summary>
        /// Returns the number of filenames in the list
        /// </summary>
        public int Count
        {
            get
            {
                return _outputFiles.Count;
            }
        }

        /// <summary>
        /// Initializing private list with provided list
        /// </summary>
        /// <param name="outputFileList">Provided list</param>
        public OutputFiles(IList<string> outputFileList)
        {
            _outputFiles = outputFileList;
        }

        /// <summary>
        /// </summary>
        /// <param name="index">The position of filename in the list</param>
        /// <returns>The filename corresponding to indexed list value </returns>
        public string GetFilename(int index)
        {
            var tmp = new StringBuilder(Path.GetFileName(_outputFiles[index]) + "\n");
            return tmp.ToString();
        }
    }
}
