﻿using System.Runtime.InteropServices;
using pdfforge.PDFCreator.Communication;
using pdfforge.PDFCreator.Threading;

namespace pdfforge.PDFCreator.COM
{
    [ComVisible(true)]
    [InterfaceType(ComInterfaceType.InterfaceIsDual)]
    [Guid("A1F6647E-8C19-4A3E-89DF-7FDFAD2A0C30")]
    public interface IPDFCreator
    {
        Printers GetPDFCreatorPrinters { get; }
        bool IsInstanceRunning { get; }
    }

    [ComVisible(true)]
    [ClassInterface(ClassInterfaceType.AutoDispatch)]
    [Guid("69189C58-70C4-4DF2-B94D-5D786E9AD513")]
    [ProgId("PDFCreatorBeta.PDFCreator")]
    public class PdfCreator : IPDFCreator
    {
        /// <summary>
        /// Returns a new PrinterDevices object
        /// </summary>
        public Printers GetPDFCreatorPrinters
        {
            get { return new Printers(); }
        }

        
        /// <summary>
        /// Checks if PDFCreator is running
        /// </summary>
        public bool IsInstanceRunning
        {
            get
            {
                return PipeServer.SessionServerInstanceRunning(ThreadManager.PipeName);
            }
        }
    }
}
