﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using pdfforge.PDFCreator.Helper;

namespace pdfforge.PDFCreator.COM
{
    [ComVisible(true)]
    public class Printers
    {
        /// <summary>
        /// Gets the number of actual printer
        /// </summary>
        public int Count
        {
            get
            {
                return PrinterUtil.GetPDFCreatorPrinters().Count;
            }
        }

        /// <summary>
        /// Get the name of the indexed printer of the list
        /// </summary>
        /// <param name="index">Printer position in the printer list</param>
        /// <returns>Name of the printer</returns>
        public string GetPrinterByIndex(int index)
        {
            var printerList = (IList<string>)PrinterUtil.GetPDFCreatorPrinters();

            if (index >= printerList.Count)
                throw new ArgumentException("Index must not be greater than the actual number of printers available");

            if(index < 0)
                throw new ArgumentException("Index has to be greater or equal to 0");

            return printerList[index];
        }
    }
}
